## gcc-python-plugin 0.14

=== Makefile ===
#   Copyright 2011, 2012, 2013 David Malcolm <dmalcolm@redhat.com>
#   Copyright 2011, 2012, 2013 Red Hat, Inc.
#
#   This is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see
#   <http://www.gnu.org/licenses/>.

.PHONY: all clean debug dump_gimple plugin show-ssa tarball \
	test-suite testcpychecker testcpybuilder \
	man

PLUGIN_SOURCE_FILES= \
  gcc-python.c \
  gcc-python-attribute.c \
  gcc-python-callbacks.c \
  gcc-python-callgraph.c \
  gcc-python-cfg.c \
  gcc-python-closure.c \
  gcc-python-diagnostics.c \
  gcc-python-function.c \
  gcc-python-gimple.c \
  gcc-python-location.c \
  gcc-python-option.c \
  gcc-python-parameter.c \
  gcc-python-pass.c \
  gcc-python-pretty-printer.c \
  gcc-python-rtl.c \
  gcc-python-tree.c \
  gcc-python-variable.c \
  gcc-python-version.c \
  gcc-python-wrapper.c \

PLUGIN_GENERATED_SOURCE_FILES:= \
  autogenerated-callgraph.c \
  autogenerated-casts.c \
  autogenerated-cfg.c \
  autogenerated-option.c \
  autogenerated-function.c \
  autogenerated-gimple.c \
  autogenerated-location.c \
  autogenerated-parameter.c \
  autogenerated-pass.c \
  autogenerated-pretty-printer.c \
  autogenerated-rtl.c \
  autogenerated-tree.c \
  autogenerated-variable.c

PLUGIN_OBJECT_SOURCE_FILES:= $(patsubst %.c,%.o,$(PLUGIN_SOURCE_FILES))
PLUGIN_OBJECT_GENERATED_FILES:= $(patsubst %.c,%.o,$(PLUGIN_GENERATED_SOURCE_FILES))
PLUGIN_OBJECT_FILES:= $(PLUGIN_OBJECT_SOURCE_FILES) $(PLUGIN_OBJECT_GENERATED_FILES)
GCCPLUGINS_DIR:= $(shell $(CC) --print-file-name=plugin)

GENERATOR_DEPS=cpybuilder.py wrapperbuilder.py print-gcc-version

# The plugin supports both Python 2 and Python 3
#
# In theory we could have arbitrary combinations of python versions for each
# of:
#   - python version used when running scripts during the build (e.g. to
#     generate code)
#   - python version we compile and link the plugin against
#   - when running the plugin with the cpychecker script, the python version
#     that the code is being compiled against
#
# However, to keep things simple, let's assume for now that all of these are
# the same version: we're building the plugin using the same version of Python
# as we're linking against, and that the cpychecker will be testing that same
# version of Python
#
# By default, build against "python", using "python-config" to query for
# compilation options.  You can override this by passing other values for
# PYTHON and PYTHON_CONFIG when invoking "make" (or by simply hacking up this
# file): e.g.
#    make  PYTHON=python3  PYTHON_CONFIG=python3-config  all

# The python interpreter to use:
PYTHON=python
# The python-config executable to use:
PYTHON_CONFIG=python-config

#PYTHON=python3
#PYTHON_CONFIG=python3-config

#PYTHON=python-debug
#PYTHON_CONFIG=python-debug-config

#PYTHON=python3-debug
#PYTHON_CONFIG=python3.3dm-config

PYTHON_INCLUDES=$(shell $(PYTHON_CONFIG) --includes)
PYTHON_LIBS=$(shell $(PYTHON_CONFIG) --libs)

# Support having multiple named plugins
# e.g. "python2.7" "python3.2mu" "python 3.2dmu" etc:
PLUGIN_NAME := python
PLUGIN_DSO := $(PLUGIN_NAME).so
PLUGIN_DIR := $(PLUGIN_NAME)

# For now, gcc-c-api is part of this project
# (Eventually it will be moved to its own project)
LIBGCC_C_API_SO	:= gcc-c-api/libgcc-c-api.so

CPPFLAGS+= -I$(GCCPLUGINS_DIR)/include -I$(GCCPLUGINS_DIR)/include/c-family -I. $(PYTHON_INCLUDES)
# Allow user to pick optimization, choose whether warnings are fatal,
# and choose debugging information level.
CFLAGS?=-O2 -Werror -g
# Force these settings
CFLAGS+= -fPIC -fno-strict-aliasing -Wall
LIBS+= $(PYTHON_LIBS)
ifneq "$(PLUGIN_PYTHONPATH)" ""
  CPPFLAGS+= -DPLUGIN_PYTHONPATH='"$(PLUGIN_PYTHONPATH)"'
endif

all: autogenerated-config.h testcpybuilder test-suite testcpychecker

# What still needs to be wrapped?
api-report:
	grep -nH -e "\.inner" gcc-*.c *.h generate-*.py

plugin: autogenerated-config.h $(PLUGIN_DSO)

# When running the plugin from a working copy, use LD_LIBARY_PATH=gcc-c-api
# so that the plugin can find its libgcc-c-api.so there
#
INVOCATION_ENV_VARS := LD_LIBRARY_PATH=gcc-c-api CC=$(CC)

# When installing, both the plugin and libgcc-c-api.so will be installed to
# $(GCCPLUGINS_DIR), so we give the plugin an RPATH of $(GCCPLUGINS_DIR)
# so that it finds the libgcc-c-api.so there (to support the case of having
# multiple GCCs installed)
#
$(PLUGIN_DSO): $(PLUGIN_OBJECT_FILES) $(LIBGCC_C_API_SO)
	$(CC) \
	    $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) \
	    -shared \
	    $(PLUGIN_OBJECT_FILES) \
	    -o $@ \
	    $(LIBS) \
	    -lgcc-c-api -Lgcc-c-api -Wl,-rpath=$(GCCPLUGINS_DIR)

$(LIBGCC_C_API_SO):
	cd gcc-c-api && make libgcc-c-api.so CC=$(CC)

$(PLUGIN_OBJECT_GENERATED_FILES): CPPFLAGS+= $(if $(srcdir),-I$(srcdir))

# This is the standard .c->.o recipe, but it needs to be stated
# explicitly to support the case that $(srcdir) is not blank.
$(PLUGIN_OBJECT_SOURCE_FILES) $(PLUGIN_OBJECT_GENERATED_FILES): %.o: $(srcdir)%.c autogenerated-config.h $(srcdir)gcc-python.h $(LIBGCC_C_API_SO) autogenerated-EXTRA_CFLAGS.txt
	$(COMPILE.c) $(shell cat autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) $<

print-gcc-version: print-gcc-version.c autogenerated-EXTRA_CFLAGS.txt
	$(CC) \
		$(CPPFLAGS) $(CFLAGS) \
		$(shell cat autogenerated-EXTRA_CFLAGS.txt) \
		-o $@ \
		$<

clean:
	$(RM) *.so *.o gcc-c-api/*.o autogenerated*
	$(RM) -r docs/_build
	$(RM) -f gcc-with-$(PLUGIN_NAME).1 gcc-with-$(PLUGIN_NAME).1.gz
	$(RM) -f print-gcc-version
	cd gcc-c-api && make clean
	find tests -name "*.o" -delete

autogenerated-config.h: $(addprefix $(srcdir),generate-config-h.py configbuilder.py)
	$(PYTHON) $< -o $@ --gcc="$(CC)" --plugindir="$(GCCPLUGINS_DIR)"

autogenerated-%.txt: $(srcdir)%.txt.in
	$(CPP) $(CPPFLAGS) -x c-header $^ -o $@

# autogenerated-EXTRA_CFLAGS.txt is a byproduct of making
# autogenerated-config.h:
autogenerated-EXTRA_CFLAGS.txt: autogenerated-config.h

# autogenerated-casts.h is a byproduct of making autogenerated-casts.c
autogenerated-casts.h: autogenerated-casts.c

$(PLUGIN_GENERATED_SOURCE_FILES): autogenerated-%.c: $(addprefix $(srcdir),generate-%-c.py $(GENERATOR_DEPS))
	$(PYTHON) $< > $@

autogenerated-casts.c:  autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt $(srcdir)generate-casts-c.py
	$(PYTHON) $(srcdir)generate-casts-c.py autogenerated-casts.c autogenerated-casts.h

autogenerated-gimple.c: autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt $(srcdir)maketreetypes.py
autogenerated-tree.c: autogenerated-tree-types.txt $(srcdir)maketreetypes.py
autogenerated-rtl.c: autogenerated-rtl-types.txt $(srcdir)maketreetypes.py
autogenerated-variable.c: autogenerated-gimple-types.txt $(srcdir)maketreetypes.py

bindir=/usr/bin
mandir=/usr/share/man

UpperPluginName = $(shell $(PYTHON) -c"print('$(PLUGIN_NAME)'.upper())")

docs/_build/man/gcc-with-python.1: docs/gcc-with-python.rst
	cd docs && $(MAKE) man

gcc-with-$(PLUGIN_NAME).1: docs/_build/man/gcc-with-python.1
	# Fixup the generic manpage for this build:
	cp docs/_build/man/gcc-with-python.1 gcc-with-$(PLUGIN_NAME).1
	sed \
	   -i \
	   -e"s|gcc-with-python|gcc-with-$(PLUGIN_NAME)|g" \
	   gcc-with-$(PLUGIN_NAME).1
	sed \
	   -i \
	   -e"s|GCC-WITH-PYTHON|GCC-WITH-$(UpperPluginName)|g" \
	   gcc-with-$(PLUGIN_NAME).1

gcc-with-$(PLUGIN_NAME).1.gz: gcc-with-$(PLUGIN_NAME).1
	rm -f gcc-with-$(PLUGIN_NAME).1.gz
	gzip gcc-with-$(PLUGIN_NAME).1

man: gcc-with-$(PLUGIN_NAME).1.gz

install: $(PLUGIN_DSO) gcc-with-$(PLUGIN_NAME).1.gz
	mkdir -p $(DESTDIR)$(GCCPLUGINS_DIR)

	cd gcc-c-api && $(MAKE) install

	cp $(PLUGIN_DSO) $(DESTDIR)$(GCCPLUGINS_DIR)

	mkdir -p $(DESTDIR)$(GCCPLUGINS_DIR)/$(PLUGIN_DIR)
	cp -a gccutils $(DESTDIR)$(GCCPLUGINS_DIR)/$(PLUGIN_DIR)
	cp -a libcpychecker $(DESTDIR)$(GCCPLUGINS_DIR)/$(PLUGIN_DIR)

	# Create "gcc-with-" support script:
	mkdir -p $(DESTDIR)$(bindir)
	install -m 755 gcc-with-python $(DESTDIR)/$(bindir)/gcc-with-$(PLUGIN_NAME)
	# Fixup the reference to the plugin in that script, from being expressed as
	# a DSO filename with a path (for a working copy) to a name of an installed
	# plugin within GCC's search directory:
	sed \
	    -i \
	    -e"s|-fplugin=[^ ]*|-fplugin=$(PLUGIN_NAME)|" \
	    $(DESTDIR)$(bindir)/gcc-with-$(PLUGIN_NAME)

        # Fixup the plugin name within -fplugin-arg-PLUGIN_NAME-script to match the
	# name for this specific build:
	sed \
	   -i \
	   -e"s|-fplugin-arg-python-script|-fplugin-arg-$(PLUGIN_NAME)-script|" \
	   $(DESTDIR)$(bindir)/gcc-with-$(PLUGIN_NAME)

	mkdir -p $(DESTDIR)$(mandir)/man1
	cp gcc-with-$(PLUGIN_NAME).1.gz $(DESTDIR)$(mandir)/man1


# Hint for debugging: add -v to the gcc options 
# to get a command line for invoking individual subprocesses
# Doing so seems to require that paths be absolute, rather than relative
# to this directory
TEST_CFLAGS= \
  -fplugin=$(CURDIR)/$(PLUGIN_DSO) \
  -fplugin-arg-python-script=test.py

# A catch-all test for quick experimentation with the API:
test: plugin
	$(INVOCATION_ENV_VARS) $(CC) -v $(TEST_CFLAGS) $(CURDIR)/test.c

# Selftest for the cpychecker.py code:
testcpychecker: plugin
	$(INVOCATION_ENV_VARS) $(PYTHON) testcpychecker.py -v

# Selftest for the cpybuilder code:
testcpybuilder:
	$(PYTHON) testcpybuilder.py -v

dump_gimple:
	$(CC) -fdump-tree-gimple $(CURDIR)/test.c

debug: plugin
	$(INVOCATION_ENV_VARS) $(CC) -v $(TEST_CFLAGS) $(CURDIR)/test.c

# A simple demo, to make it easy to demonstrate the cpychecker:
demo: plugin
	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -c $(PYTHON_INCLUDES) demo.c

json-examples: plugin
	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -I/usr/include/python2.7 -c libcpychecker_html/test/example1/bug.c

test-suite: plugin print-gcc-version
	$(INVOCATION_ENV_VARS) $(PYTHON) run-test-suite.py

show-ssa: plugin
	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python examples/show-ssa.py test.c

html: docs/tables-of-passes.rst docs/passes.svg
	cd docs && $(MAKE) html

# We commit this generated file to SCM to allow the docs to be built without
# needing to build the plugin:
docs/tables-of-passes.rst: plugin generate-tables-of-passes-rst.py
	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python generate-tables-of-passes-rst.py test.c > $@

# Likewise for this generated file:
docs/passes.svg: plugin generate-passes-svg.py
	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python generate-passes-svg.py test.c

check-api:
	xmllint --noout --relaxng $(srcdir)./gcc-c-api/api.rng $(srcdir)./gcc-c-api/*.xml

# Utility target, to help me to make releases
#   - creates a tag in git (but does not push it; see "Notes to self on
#     making a release" below)
#   - creates a tarball
#
# The following assumes that VERSION has been set e.g.
#   $ make tarball VERSION=0.4

$(HOME)/rpmbuild/SOURCES/%.tar.gz:
	test -n "$(VERSION)"
	-git tag -d v$(VERSION)
	git tag -a v$(VERSION) -m"$(VERSION)"
	git archive --format=tar --prefix=$*/ v$(VERSION) | gzip > $*.tar.gz
	sha256sum $*.tar.gz
	cp $*.tar.gz $@

tarball: $(HOME)/rpmbuild/SOURCES/gcc-python-plugin-$(VERSION).tar.gz

# Notes to self on making a release
# ---------------------------------
#
#  Before tagging:
#
#     * update the version/release in docs/conf.py
#
#     * update the version in gcc-python-plugin.spec
#
#     * add release notes to docs
#
#  Test the candidate tarball via a scratch SRPM build locally (this
#  achieves test coverage against python 2 and 3, for both debug and

=== debian/changelog ===
gcc-python-plugin (0.14-4) unstable; urgency=medium

  * Build the manual pages on all architectures.

 -- Matthias Klose <doko@debian.org>  Sat, 11 Jul 2015 12:07:24 +0200

gcc-python-plugin (0.14-3) unstable; urgency=medium

  * Build-Depend on python3-all-dbg..

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jul 2015 19:29:31 +0200

gcc-python-plugin (0.14-2) unstable; urgency=medium

  * (Build-)Depend on g++-5.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jul 2015 16:53:03 +0200

gcc-python-plugin (0.14-1) unstable; urgency=low

  * Initial release (Closes: #787365).

 -- Matthias Klose <doko@debian.org>  Sat, 30 May 2015 10:36:24 +0000

=== debian/control ===
Source: gcc-python-plugin
Section: devel
Priority: optional
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dh-python,
  gcc-5-plugin-dev, g++-5,
  python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
#  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
  python3-sphinx
Standards-Version: 3.9.6
Homepage: https://fedorahosted.org/gcc-python-plugin/

Package: gcc-python3-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
  python3-lxml, python3-pygments, python3-six,
  gcc-5, g++-5
Recommends: www-browser, xdg-utils, graphviz
Suggests: gcc-python-plugin-doc
Description: plugin for GCC to invoke Python scripts from inside the compiler
 The GCC Python plugin is a plugin for GCC, which links against libpython,
 and allows you to invoke arbitrary Python scripts from inside the compiler.
 The aim is to allow you to write GCC plugins in Python.

Package: gcc-python3-dbg-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
  gcc-python3-plugin (= ${binary:Version}), python3-lxml-dbg
Suggests: gcc-python-plugin-doc
Description: plugin for GCC to invoke Python scripts from inside the compiler
 The GCC Python plugin is a plugin for GCC, which links against libpython,
 and allows you to invoke arbitrary Python scripts from inside the compiler.
 The aim is to allow you to write GCC plugins in Python.

Package: gcc-python-plugin-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: plugin for GCC to invoke Python scripts from inside the compiler
 The GCC Python plugin is a plugin for GCC, which links against libpython,
 and allows you to invoke arbitrary Python scripts from inside the compiler.
 The aim is to allow you to write GCC plugins in Python.
 .
 This package contains the documentation.

## gcc-python-plugin 0.15

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make a Texinfo document"
	@echo "  info       to make an info page"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/gcc-python-plugin.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/gcc-python-plugin.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/gcc-python-plugin"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/gcc-python-plugin"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo pages are in $(BUILDDIR)/texinfo."

info: texinfo
	cd $(BUILDDIR)/texinfo && $(MAKE) info
	@echo
	@echo "Build finished. The info pages are in $(BUILDDIR)/texinfo."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== gcc-c-api/Makefile ===
#   Copyright 2011, 2012, 2013 David Malcolm <dmalcolm@redhat.com>
#   Copyright 2011, 2012, 2013 Red Hat, Inc.
#
#   This is free software: you can redistribute it and/or modify it
#   under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see
#   <http://www.gnu.org/licenses/>.

.PHONY: all clean check-api

HANDWRITTEN_C_FILES = \
  gcc-callgraph.c \
  gcc-cfg.c \
  gcc-constant.c \
  gcc-declaration.c \
  gcc-diagnostics.c \
  gcc-function.c \
  gcc-gimple.c \
  gcc-location.c \
  gcc-option.c \
  gcc-rtl.c \
  gcc-tree.c \
  gcc-type.c \
  gcc-variable.c

GENERATED_C_FILES = \
  autogenerated-casts.c

OBJECT_FILES_FROM_HANDWRITTEN_C_FILES:= $(patsubst %.c,%.o,$(HANDWRITTEN_C_FILES))
OBJECT_FILES_FROM_GENERATED_C_FILES:= $(patsubst %.c,%.o,$(GENERATED_C_FILES))

OBJECT_FILES:= $(OBJECT_FILES_FROM_HANDWRITTEN_C_FILES) $(OBJECT_FILES_FROM_GENERATED_C_FILES)

SOURCE_XML:= \
  callgraph.xml \
  cfg.xml \
  constant.xml \
  declaration.xml \
  function.xml \
  gimple.xml \
  location.xml \
  option.xml \
  rtl.xml \
  tree.xml \
  type.xml \
  variable.xml

GENERATED_HEADERS:= \
  gcc-public-types.h \
  gcc-semiprivate-types.h \
  gcc-callgraph.h \
  gcc-cfg.h \
  gcc-constant.h \
  gcc-declaration.h \
  gcc-function.h \
  gcc-gimple.h \
  gcc-location.h \
  gcc-option.h \
  gcc-rtl.h \
  gcc-tree.h \
  gcc-type.h \
  gcc-variable.h

GCCPLUGINS_DIR:= $(shell $(CC) --print-file-name=plugin)

LIBGCC_C_API_SO	:= libgcc-c-api.so

CPPFLAGS+= -I$(GCCPLUGINS_DIR)/include -I$(GCCPLUGINS_DIR)/include/c-family -I.
# Allow user to pick optimization, choose whether warnings are fatal,
# and choose debugging information level.
CFLAGS?=-O2 -Werror -g
# Force these settings
CFLAGS+= -fPIC -fno-strict-aliasing -Wall

all: $(LIBGCC_C_API_SO)

$(LIBGCC_C_API_SO): $(OBJECT_FILES)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -shared $^ -o $@ $(LIBS)

# This is the standard .c->.o recipe, but it needs to be stated
# explicitly to support the case that $(srcdir) is not blank.
$(OBJECT_FILES): %.o: $(srcdir)%.c $(GENERATED_HEADERS) ../autogenerated-EXTRA_CFLAGS.txt
	$(COMPILE.c) $(shell cat ../autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) $<

autogenerated-casts.c: $(SOURCE_XML) xmltypes.py generate-casts-c.py
	$(PYTHON) generate-casts-c.py $@

clean:
	$(RM) *.so *.o $(GENERATED_HEADERS)

install: $(LIBGCC_C_API_SO)
	mkdir -p $(DESTDIR)$(GCCPLUGINS_DIR)
	cp libgcc-c-api.so $(DESTDIR)$(GCCPLUGINS_DIR)

# The python interpreter to use:
PYTHON=python

$(GENERATED_HEADERS): $(SOURCE_XML) xml-to-h.py xmltypes.py
	$(PYTHON) xml-to-h.py

check-api:
	xmllint --noout --relaxng api.rng *.xml

=== debian/changelog ===
gcc-python-plugin (0.15-4) unstable; urgency=medium

  * Build using GCC 7.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Fri, 08 Sep 2017 11:22:42 +0200

gcc-python-plugin (0.15-3) unstable; urgency=medium

  * Build using GCC 6.

 -- Matthias Klose <doko@debian.org>  Wed, 24 Aug 2016 10:02:56 +0200

gcc-python-plugin (0.15-2) unstable; urgency=medium

  * No-change rebuild. Closes: #818400.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Apr 2016 14:02:19 +0200

gcc-python-plugin (0.15-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 20 Feb 2016 22:15:56 +0100

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,19 @@
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dh-python,
-  gcc-5-plugin-dev, g++-5,
+  gcc-7-plugin-dev, g++-7,
   python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
 #  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
   python3-sphinx
-Standards-Version: 3.9.6
+Standards-Version: 4.1.0
 Homepage: https://fedorahosted.org/gcc-python-plugin/
 
 Package: gcc-python3-plugin
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   python3-lxml, python3-pygments, python3-six,
-  gcc-5, g++-5
+  gcc-7, g++-7
 Recommends: www-browser, xdg-utils, graphviz
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler
@@ -25,6 +26,7 @@
 
 Package: gcc-python3-dbg-plugin
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   gcc-python3-plugin (= ${binary:Version}), python3-lxml-dbg
 Suggests: gcc-python-plugin-doc
@@ -35,6 +37,7 @@
 
 Package: gcc-python-plugin-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: plugin for GCC to invoke Python scripts from inside the compiler

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

CC 	= gcc-7
PYTHON	= python
p3	= gcc-python3-plugin
d3	= debian/$(p3)
p3dbg	= gcc-python3-dbg-plugin
d3dbg	= debian/$(p3dbg)
pdoc	= gcc-python-plugin-doc
ddoc	= debian/$(pdoc)

INTERP	= python3 python3-dbg # python python-dbg

export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

build-arch: $(INTERP:%=build-stamp-%)
build-indep: doc-stamp
build: $(INTERP:%=build-stamp-%) $(INTERP:%=check-stamp-%)
build-stamp-%:
	dh_testdir
	rm -rf build-$*
	mkdir -p build-$*
	tar -c -f - --exclude=debian --exclude=build-* . | tar -C build-$* -x -f -
	$(MAKE) -C build-$* \
	  CC=$(CC) \
	  PYTHON=$* PYTHON_CONFIG=$*-config \
	  PLUGIN_NAME=$(subst -,_,$*) \
	  PLUGIN_DSO=$(subst -,_,$*.so) \
	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
	  plugin print-gcc-version
	touch $@

check-stamp-%: build-stamp-%
	dh_testdir
	: # TODO: see the spec file for XFAIL tests
	-$(MAKE) -C build-$* \
	  CC=$(CC) \
	  PYTHON=$* PYTHON_CONFIG=$*-config \
	  PLUGIN_NAME=$(subst -,_,$*) \
	  PLUGIN_DSO=$(subst -,_,$*.so) \
	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
	  all
	touch $@

doc-stamp:
	dh_testdir
	$(MAKE) -C docs html
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp* check-stamp* doc-stamp
	rm -rf build-*
	$(MAKE) -C docs clean
	find -type d -name __pycache__ | xargs -r rm -rf
	find -type f -name '*.py[co]'  | xargs -r rm -f
	dh_clean 

pre-install:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

install-%: build-stamp-%
	dh_testdir
	dh_testroot
	$(MAKE) -C build-$* \
	  CC=$(CC) \
	  PYTHON=$* PYTHON_CONFIG=$*-config \
	  PLUGIN_NAME=$(subst -,_,$*) \
	  PLUGIN_DSO=$(subst -,_,$*.so) \
	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
	  DESTDIR=$(CURDIR)/debian/gcc-$*-plugin \
	  install
	set -x; \
	p="gcc-$*-plugin"; \
	src="$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*)"; \
	dst="usr/lib/$(if $(findstring python3, $*),python3,python2.7)/dist-packages"; \
	mkdir -p debian/$$p/$$dst; \
	for d in gccutils libcpychecker; do \
	  tar -C debian/$$p/$$src -c -f - $$d \
	    | tar -C debian/$$p/$$dst -x -f -; \
	  rm -rf debian/$$p/$$src/$$d; \
	  dh_link -p$$p /$$dst/$$d /$$src/$$d; \
	done; \
	$(if $(findstring dbg,$*), \
	  rm -f debian/$$p/$$src/../libgcc-c-api.so; \
	  rm -rf debian/$$p/$$dst; \
	)

install: pre-install $(INTERP:%=install-%)
	dh_testdir
	dh_testroot
	find $(d) -type d -name __pycache__ | xargs -r rm -rf
	find $(d) -type f -name '*.py[co]'  | xargs -r rm -f

# Build architecture-independent files here.
binary-indep: install doc-stamp
	dh_testdir
	dh_testroot
	dh_installchangelogs -i
	dh_installdocs -p$(pdoc) docs/_build/html
	cp -a examples $(ddoc)/usr/share/doc/$(pdoc)/.
	dh_sphinxdoc -i
	dh_lintian -i
	dh_compress -i -X.py
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a
	dh_installdocs -a
#	dh_python2 -a
	dh_python3 -a --no-dbg-cleaning
	dh_installman -a
	dh_link -a
#	dh_strip -p$(p2) --dbg-package=$(p2dbg)
	dh_strip -p$(p3) --dbg-package=$(p3dbg)
	rm -rf debian/$(p3dbg)/usr/share/doc/$(p3dbg)
	ln -s $(p3) debian/$(p3dbg)/usr/share/doc/$(p3dbg)
	dh_lintian -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.NOTPARALLEL:
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
https://fedorahosted.org/releases/g/c/gcc-python-plugin/gcc-python-plugin-(.*).tar.gz

## gcc-python-plugin 0.16

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-#   Copyright 2011, 2012, 2013 David Malcolm <dmalcolm@redhat.com>
-#   Copyright 2011, 2012, 2013 Red Hat, Inc.
+#   Copyright 2011-2013, 2017 David Malcolm <dmalcolm@redhat.com>
+#   Copyright 2011-2013, 2017 Red Hat, Inc.
 #
 #   This is free software: you can redistribute it and/or modify it
 #   under the terms of the GNU General Public License as published by
@@ -16,7 +16,7 @@
 #   <http://www.gnu.org/licenses/>.
 
 .PHONY: all clean debug dump_gimple plugin show-ssa tarball \
-	test-suite testcpychecker testcpybuilder \
+	test-suite testcpychecker testcpybuilder testdejagnu \
 	man
 
 PLUGIN_SOURCE_FILES= \
@@ -121,7 +121,7 @@
   CPPFLAGS+= -DPLUGIN_PYTHONPATH='"$(PLUGIN_PYTHONPATH)"'
 endif
 
-all: autogenerated-config.h testcpybuilder test-suite testcpychecker
+all: autogenerated-config.h testcpybuilder testdejagnu test-suite testcpychecker
 
 # What still needs to be wrapped?
 api-report:
@@ -276,6 +276,10 @@
 testcpybuilder:
 	$(PYTHON) testcpybuilder.py -v
 
+# Selftest for the dejagnu.py code:
+testdejagnu:
+	$(PYTHON) dejagnu.py -v
+
 dump_gimple:
 	$(CC) -fdump-tree-gimple $(CURDIR)/test.c
 
@@ -289,11 +293,18 @@
 json-examples: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -I/usr/include/python2.7 -c libcpychecker_html/test/example1/bug.c
 
-test-suite: plugin print-gcc-version
+test-suite: plugin print-gcc-version testdejagnu
 	$(INVOCATION_ENV_VARS) $(PYTHON) run-test-suite.py
 
 show-ssa: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python examples/show-ssa.py test.c
+
+demo-show-lto-supergraph: plugin
+	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python \
+	  examples/show-lto-supergraph.py \
+	  -flto \
+	  -flto-partition=none \
+	  tests/examples/lto/input-*.c
 
 html: docs/tables-of-passes.rst docs/passes.svg
 	cd docs && $(MAKE) html
@@ -333,11 +344,3 @@
 #
 #  Before tagging:
 #
-#     * update the version/release in docs/conf.py
-#
-#     * update the version in gcc-python-plugin.spec
-#
-#     * add release notes to docs
-#
-#  Test the candidate tarball via a scratch SRPM build locally (this
-#  achieves test coverage against python 2 and 3, for both debug and

=== debian/changelog ===
gcc-python-plugin (0.16-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 05 May 2018 14:25:56 +0200

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,19 @@
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dh-python,
   gcc-7-plugin-dev, g++-7,
+  gcc-8-plugin-dev, g++-8,
   python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
 #  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
   python3-sphinx
-Standards-Version: 4.1.0
-Homepage: https://fedorahosted.org/gcc-python-plugin/
+Standards-Version: 4.1.4
+Homepage: https://github.com/davidmalcolm/gcc-python-plugin
 
 Package: gcc-python3-plugin
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   python3-lxml, python3-pygments, python3-six,
-  gcc-7, g++-7
+  gcc-7 | gcc-8, g++-7 | g++-8
 Recommends: www-browser, xdg-utils, graphviz
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # -*- makefile -*-
 
 CC 	= gcc-7
+ALT_CC 	= gcc-8
 PYTHON	= python
 p3	= gcc-python3-plugin
 d3	= debian/$(p3)
@@ -29,6 +30,18 @@
 	  PLUGIN_DSO=$(subst -,_,$*.so) \
 	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
 	  plugin print-gcc-version
+ifneq (,$(ALT_CC))
+	rm -rf build-alt-$*
+	mkdir -p build-alt-$*
+	tar -c -f - --exclude=debian --exclude=build-* . | tar -C build-alt-$* -x -f -
+	$(MAKE) -C build-alt-$* \
+	  CC=$(ALT_CC) \
+	  PYTHON=$* PYTHON_CONFIG=$*-config \
+	  PLUGIN_NAME=$(subst -,_,$*) \
+	  PLUGIN_DSO=$(subst -,_,$*.so) \
+	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
+	  plugin print-gcc-version
+endif
 	touch $@
 
 check-stamp-%: build-stamp-%
@@ -41,6 +54,15 @@
 	  PLUGIN_DSO=$(subst -,_,$*.so) \
 	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
 	  all
+ifneq (,$(ALT_CC))
+	-$(MAKE) -C build-alt-$* \
+	  CC=$(ALT_CC) \
+	  PYTHON=$* PYTHON_CONFIG=$*-config \
+	  PLUGIN_NAME=$(subst -,_,$*) \
+	  PLUGIN_DSO=$(subst -,_,$*.so) \
+	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
+	  all
+endif
 	touch $@
 
 doc-stamp:
@@ -51,7 +73,7 @@
 clean: 
 	dh_testdir
 	dh_testroot
-	rm -f build-stamp* check-stamp* doc-stamp
+	rm -f build*-stamp* check*-stamp* doc-stamp
 	rm -rf build-*
 	$(MAKE) -C docs clean
 	find -type d -name __pycache__ | xargs -r rm -rf
@@ -67,6 +89,31 @@
 install-%: build-stamp-%
 	dh_testdir
 	dh_testroot
+ifneq (,$(ALT_CC))
+	$(MAKE) -C build-alt-$* \
+	  CC=$(ALT_CC) \
+	  PYTHON=$* PYTHON_CONFIG=$*-config \
+	  PLUGIN_NAME=$(subst -,_,$*) \
+	  PLUGIN_DSO=$(subst -,_,$*.so) \
+	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
+	  DESTDIR=$(CURDIR)/debian/gcc-$*-plugin \
+	  install
+	set -x; \
+	p="gcc-$*-plugin"; \
+	src="$(shell $(ALT_CC) --print-file-name=plugin)/$(subst -,_,$*)"; \
+	dst="usr/lib/$(if $(findstring python3, $*),python3,python2.7)/dist-packages"; \
+	mkdir -p debian/$$p/$$dst; \
+	for d in gccutils libcpychecker; do \
+	  tar -C debian/$$p/$$src -c -f - $$d \
+	    | tar -C debian/$$p/$$dst -x -f -; \
+	  rm -rf debian/$$p/$$src/$$d; \
+	  dh_link -p$$p /$$dst/$$d /$$src/$$d; \
+	done; \
+	$(if $(findstring dbg,$*), \
+	  rm -f debian/$$p/$$src/../libgcc-c-api.so; \
+	  rm -rf debian/$$p/$$dst; \
+	)
+endif
 	$(MAKE) -C build-$* \
 	  CC=$(CC) \
 	  PYTHON=$* PYTHON_CONFIG=$*-config \

## gcc-python-plugin 0.17

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,12 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see
 #   <http://www.gnu.org/licenses/>.
+
+ifneq ($(srcdir),)
+VPATH = $(srcdir)
+endif
+xmldir = $(srcdir)./gcc-c-api/
+pwd = $(shell pwd -P)
 
 .PHONY: all clean debug dump_gimple plugin show-ssa tarball \
 	test-suite testcpychecker testcpybuilder testdejagnu \
@@ -132,7 +138,7 @@
 # When running the plugin from a working copy, use LD_LIBARY_PATH=gcc-c-api
 # so that the plugin can find its libgcc-c-api.so there
 #
-INVOCATION_ENV_VARS := LD_LIBRARY_PATH=gcc-c-api CC=$(CC)
+INVOCATION_ENV_VARS := PYTHONPATH=$(srcdir)./ CC_FOR_CPYCHECKER=$(CC) LD_LIBRARY_PATH=gcc-c-api:$(LD_LIBRARY_PATH) CC=$(CC)
 
 # When installing, both the plugin and libgcc-c-api.so will be installed to
 # $(GCCPLUGINS_DIR), so we give the plugin an RPATH of $(GCCPLUGINS_DIR)
@@ -148,15 +154,18 @@
 	    $(LIBS) \
 	    -lgcc-c-api -Lgcc-c-api -Wl,-rpath=$(GCCPLUGINS_DIR)
 
-$(LIBGCC_C_API_SO):
-	cd gcc-c-api && make libgcc-c-api.so CC=$(CC)
+$(pwd)/gcc-c-api:
+	mkdir -p $@
+
+$(LIBGCC_C_API_SO): $(pwd)/gcc-c-api
+	cd gcc-c-api && make $(if $(srcdir),-f $(srcdir)./gcc-c-api/Makefile) libgcc-c-api.so CC=$(CC) $(if $(srcdir),srcdir=$(srcdir)./gcc-c-api/)
 
 $(PLUGIN_OBJECT_GENERATED_FILES): CPPFLAGS+= $(if $(srcdir),-I$(srcdir))
 
 # This is the standard .c->.o recipe, but it needs to be stated
 # explicitly to support the case that $(srcdir) is not blank.
-$(PLUGIN_OBJECT_SOURCE_FILES) $(PLUGIN_OBJECT_GENERATED_FILES): %.o: $(srcdir)%.c autogenerated-config.h $(srcdir)gcc-python.h $(LIBGCC_C_API_SO) autogenerated-EXTRA_CFLAGS.txt
-	$(COMPILE.c) $(shell cat autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) $<
+$(PLUGIN_OBJECT_FILES): %.o: %.c autogenerated-config.h gcc-python.h $(LIBGCC_C_API_SO) autogenerated-EXTRA_CFLAGS.txt
+	$(COMPILE.c) $(shell cat autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) -I$(srcdir)./ -I$(srcdir)./gcc-c-api -I./gcc-c-api $<
 
 print-gcc-version: print-gcc-version.c autogenerated-EXTRA_CFLAGS.txt
 	$(CC) \
@@ -173,10 +182,10 @@
 	cd gcc-c-api && make clean
 	find tests -name "*.o" -delete
 
-autogenerated-config.h: $(addprefix $(srcdir),generate-config-h.py configbuilder.py)
+autogenerated-config.h: generate-config-h.py configbuilder.py
 	$(PYTHON) $< -o $@ --gcc="$(CC)" --plugindir="$(GCCPLUGINS_DIR)"
 
-autogenerated-%.txt: $(srcdir)%.txt.in
+autogenerated-%.txt: %.txt.in
 	$(CPP) $(CPPFLAGS) -x c-header $^ -o $@
 
 # autogenerated-EXTRA_CFLAGS.txt is a byproduct of making
@@ -186,16 +195,16 @@
 # autogenerated-casts.h is a byproduct of making autogenerated-casts.c
 autogenerated-casts.h: autogenerated-casts.c
 
-$(PLUGIN_GENERATED_SOURCE_FILES): autogenerated-%.c: $(addprefix $(srcdir),generate-%-c.py $(GENERATOR_DEPS))
+$(PLUGIN_GENERATED_SOURCE_FILES): autogenerated-%.c: generate-%-c.py $(GENERATOR_DEPS)
 	$(PYTHON) $< > $@
 
-autogenerated-casts.c:  autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt $(srcdir)generate-casts-c.py
-	$(PYTHON) $(srcdir)generate-casts-c.py autogenerated-casts.c autogenerated-casts.h
-
-autogenerated-gimple.c: autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt $(srcdir)maketreetypes.py
-autogenerated-tree.c: autogenerated-tree-types.txt $(srcdir)maketreetypes.py
-autogenerated-rtl.c: autogenerated-rtl-types.txt $(srcdir)maketreetypes.py
-autogenerated-variable.c: autogenerated-gimple-types.txt $(srcdir)maketreetypes.py
+autogenerated-casts.c:  autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt generate-casts-c.py
+	PYTHONPATH=$(srcdir)./gcc-c-api	$(PYTHON) $(srcdir)generate-casts-c.py autogenerated-casts.c autogenerated-casts.h $(xmldir)
+
+autogenerated-gimple.c: autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt maketreetypes.py
+autogenerated-tree.c: autogenerated-tree-types.txt maketreetypes.py
+autogenerated-rtl.c: autogenerated-rtl-types.txt maketreetypes.py
+autogenerated-variable.c: autogenerated-gimple-types.txt maketreetypes.py
 
 bindir=/usr/bin
 mandir=/usr/share/man
@@ -270,15 +279,15 @@
 
 # Selftest for the cpychecker.py code:
 testcpychecker: plugin
-	$(INVOCATION_ENV_VARS) $(PYTHON) testcpychecker.py -v
+	$(INVOCATION_ENV_VARS) $(PYTHON) $(srcdir)./testcpychecker.py -v
 
 # Selftest for the cpybuilder code:
 testcpybuilder:
-	$(PYTHON) testcpybuilder.py -v
+	$(PYTHON) $(srcdir)./testcpybuilder.py -v
 
 # Selftest for the dejagnu.py code:
 testdejagnu:
-	$(PYTHON) dejagnu.py -v
+	$(PYTHON) $(srcdir)./dejagnu.py -v
 
 dump_gimple:
 	$(CC) -fdump-tree-gimple $(CURDIR)/test.c
@@ -286,15 +295,35 @@
 debug: plugin
 	$(INVOCATION_ENV_VARS) $(CC) -v $(TEST_CFLAGS) $(CURDIR)/test.c
 
+$(pwd)/gcc-with-cpychecker: gcc-with-cpychecker
+	cp $< $@
+
 # A simple demo, to make it easy to demonstrate the cpychecker:
-demo: plugin
-	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -c $(PYTHON_INCLUDES) demo.c
+demo: demo.c plugin $(pwd)/gcc-with-cpychecker
+	$(INVOCATION_ENV_VARS) ./gcc-with-cpychecker -c $(PYTHON_INCLUDES) $<
+
+# Run 'demo', and verify the output.
+testdemo: DEMO_REF=$(shell \
+	if [ $$(./print-gcc-version) -ge 7000 ]; then \
+		echo demo.expected.no-refcounts; \
+	else \
+		echo demo.expected; \
+	fi)
+testdemo: plugin print-gcc-version
+	$(MAKE) -f $(srcdir)./Makefile demo > demo.out 2> demo.err
+	egrep '^.*demo.c:( In function |[0-9][0-9]*:[0-9][0-9]*: warning:)' \
+	  demo.err \
+	  | sed 's/:[0-9][0-9]*: warning:/:: warning:/;s/ \[enabled by default\]//' \
+	  | sed "s%$(srcdir)demo.c:%demo.c:%g" \
+	  > demo.filtered
+	diff $(srcdir)./$(DEMO_REF) demo.filtered
+	rm demo.out demo.err demo.filtered
 
 json-examples: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -I/usr/include/python2.7 -c libcpychecker_html/test/example1/bug.c
 
-test-suite: plugin print-gcc-version testdejagnu
-	$(INVOCATION_ENV_VARS) $(PYTHON) run-test-suite.py
+test-suite: plugin print-gcc-version testdejagnu testdemo
+	$(INVOCATION_ENV_VARS) $(PYTHON) $(srcdir)./run-test-suite.py $(if $(srcdir),--srcdir=$(srcdir))
 
 show-ssa: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python examples/show-ssa.py test.c
@@ -312,35 +341,3 @@
 # We commit this generated file to SCM to allow the docs to be built without
 # needing to build the plugin:
 docs/tables-of-passes.rst: plugin generate-tables-of-passes-rst.py
-	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python generate-tables-of-passes-rst.py test.c > $@
-
-# Likewise for this generated file:
-docs/passes.svg: plugin generate-passes-svg.py
-	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python generate-passes-svg.py test.c
-
-check-api:
-	xmllint --noout --relaxng $(srcdir)./gcc-c-api/api.rng $(srcdir)./gcc-c-api/*.xml
-
-# Utility target, to help me to make releases
-#   - creates a tag in git (but does not push it; see "Notes to self on
-#     making a release" below)
-#   - creates a tarball
-#
-# The following assumes that VERSION has been set e.g.
-#   $ make tarball VERSION=0.4
-
-$(HOME)/rpmbuild/SOURCES/%.tar.gz:
-	test -n "$(VERSION)"
-	-git tag -d v$(VERSION)
-	git tag -a v$(VERSION) -m"$(VERSION)"
-	git archive --format=tar --prefix=$*/ v$(VERSION) | gzip > $*.tar.gz
-	sha256sum $*.tar.gz
-	cp $*.tar.gz $@
-
-tarball: $(HOME)/rpmbuild/SOURCES/gcc-python-plugin-$(VERSION).tar.gz
-
-# Notes to self on making a release
-# ---------------------------------
-#
-#  Before tagging:
-#

=== gcc-c-api/Makefile ===
--- 
+++ 
@@ -14,6 +14,11 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see
 #   <http://www.gnu.org/licenses/>.
+
+ifneq ($(srcdir),)
+VPATH = $(srcdir)
+endif
+xmldir = $(srcdir)./
 
 .PHONY: all clean check-api
 
@@ -45,6 +50,7 @@
   cfg.xml \
   constant.xml \
   declaration.xml \
+  diagnostics.xml \
   function.xml \
   gimple.xml \
   location.xml \
@@ -88,11 +94,11 @@
 
 # This is the standard .c->.o recipe, but it needs to be stated
 # explicitly to support the case that $(srcdir) is not blank.
-$(OBJECT_FILES): %.o: $(srcdir)%.c $(GENERATED_HEADERS) ../autogenerated-EXTRA_CFLAGS.txt
-	$(COMPILE.c) $(shell cat ../autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) $<
+$(OBJECT_FILES): %.o: %.c $(GENERATED_HEADERS) ../autogenerated-EXTRA_CFLAGS.txt
+	$(COMPILE.c) $(shell cat ../autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) -I$(srcdir)./ $<
 
 autogenerated-casts.c: $(SOURCE_XML) xmltypes.py generate-casts-c.py
-	$(PYTHON) generate-casts-c.py $@
+	$(PYTHON) $(srcdir)./generate-casts-c.py $@ $(xmldir)
 
 clean:
 	$(RM) *.so *.o $(GENERATED_HEADERS)
@@ -105,7 +111,7 @@
 PYTHON=python
 
 $(GENERATED_HEADERS): $(SOURCE_XML) xml-to-h.py xmltypes.py
-	$(PYTHON) xml-to-h.py
+	$(PYTHON) $(srcdir)./xml-to-h.py $(xmldir)
 
 check-api:
 	xmllint --noout --relaxng api.rng *.xml

=== debian/changelog ===
gcc-python-plugin (0.17-6ubuntu2) jammy; urgency=medium

  * Remove dependency from dbg package to removed python3-lxml-dbg

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 16 Dec 2021 11:31:58 +0100

gcc-python-plugin (0.17-6ubuntu1) jammy; urgency=medium

  * Don't fail the build on deprecated python functions.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 19 Nov 2021 19:24:09 +0000

gcc-python-plugin (0.17-6build2) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Oct 2021 12:21:20 +0200

gcc-python-plugin (0.17-6) unstable; urgency=medium

  * debian/patches/python3.8-compat.patch: fix compatibility with
    Python 3.8 (Steve Langasek). Closes: #951752.

 -- Matthias Klose <doko@debian.org>  Sun, 05 Apr 2020 15:40:16 +0200

gcc-python-plugin (0.17-5) unstable; urgency=medium

  * Ignore a compiler warning seen with Python 3.8.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 20 Feb 2020 14:15:45 +0100

gcc-python-plugin (0.17-4) unstable; urgency=medium

  * Stop building for GCC 8.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Nov 2019 10:53:18 +0100

gcc-python-plugin (0.17-3) unstable; urgency=medium

  * Build for GCC 9.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sat, 20 Jul 2019 01:12:02 +0200

gcc-python-plugin (0.17-2) unstable; urgency=medium

  * Fix build failure with GCC 8.3. Closes: #924097.

 -- Matthias Klose <doko@debian.org>  Sat, 09 Mar 2019 18:31:48 +0100

gcc-python-plugin (0.17-1ubuntu1) disco; urgency=medium

  * Build for GCC 9 as well.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Feb 2019 09:17:36 +0100

gcc-python-plugin (0.17-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 24 Jan 2019 09:27:49 +0100

gcc-python-plugin (0.16-2) unstable; urgency=medium

  * Stop building for GCC 7.

 -- Matthias Klose <doko@debian.org>  Sat, 21 Jul 2018 13:35:19 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: gcc-python-plugin
 Section: devel
 Priority: optional
-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dh-python,
-  gcc-7-plugin-dev, g++-7,
-  gcc-8-plugin-dev, g++-8,
+  gcc-9-plugin-dev, g++-9,
+  gcc-10-plugin-dev, g++-10,
   python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
-#  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
   python3-sphinx
-Standards-Version: 4.1.4
+Standards-Version: 4.5.0
 Homepage: https://github.com/davidmalcolm/gcc-python-plugin
 
 Package: gcc-python3-plugin
@@ -17,7 +17,7 @@
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   python3-lxml, python3-pygments, python3-six,
-  gcc-7 | gcc-8, g++-7 | g++-8
+  g++-9
 Recommends: www-browser, xdg-utils, graphviz
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler
@@ -29,7 +29,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
-  gcc-python3-plugin (= ${binary:Version}), python3-lxml-dbg
+  gcc-python3-plugin (= ${binary:Version})
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler
  The GCC Python plugin is a plugin for GCC, which links against libpython,

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-CC 	= gcc-7
-ALT_CC 	= gcc-8
+CC 	= gcc-9
+#ALT_CC 	= gcc-10
 PYTHON	= python
 p3	= gcc-python3-plugin
 d3	= debian/$(p3)
@@ -14,6 +14,7 @@
 INTERP	= python3 python3-dbg # python python-dbg
 
 export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+export CFLAGS := $(shell env DEB_CFLAGS_MAINT_APPEND=-Wno-error=deprecated-declarations dpkg-buildflags --get CFLAGS)
 
 build-arch: $(INTERP:%=build-stamp-%)
 build-indep: doc-stamp

=== debian/watch ===
version=3
https://github.com/davidmalcolm/gcc-python-plugin/tags .*/v?(\d\S+)\.tar\.gz
